/** Figure.java.l
 *
 *  Basisklasse zweidimensionaler geometrischer Objekte
 */

import java.awt.*;

public abstract class Figure {

  // Datenelement
  private Point p;

  // Konstruktoren
  protected Figure() {
 	p = new Point();
  }

  protected Figure(int x, int y) {
	p = new Point(x,y);
  }

  protected Figure(int x, int y, String color) {
	p = new Point(x,y,color);
  }

  // Methoden zum Abfragen von Attributen

  public Point getPoint() {
	return p;
  }

  // wandelt gueltige String-Werte von p.color
  // in passende Instanzen von java.awt.Color um;
  // default: Color.black
  public Color getColor() {		
	if (p.getColor().equals("blue"))
		return Color.blue;
	else if (p.getColor().equals("cyan"))
		return Color.cyan;
	else if (p.getColor().equals("darkGray"))
		return Color.darkGray;
	else if (p.getColor().equals("gray"))
		return Color.gray;
	else if (p.getColor().equals("green"))
		return Color.green;
	else if (p.getColor().equals("lightGray"))
		return Color.lightGray;
	else if (p.getColor().equals("magenta"))
		return Color.magenta;
	else if (p.getColor().equals("orange"))
		return Color.orange;
	else if (p.getColor().equals("pink"))
		return Color.pink;
	else if (p.getColor().equals("red"))
		return Color.red;
	else if (p.getColor().equals("white"))
		return Color.white;
	else if (p.getColor().equals("yellow"))
		return Color.yellow;
	else return Color.black;
  }

  // Methoden absolutes Verschieben
  public void moveTo(int xNew, int yNew) {
	p.moveTo(xNew,yNew);
  }

  // Methode zum Umfaerben
  public void setColor(String colorNew) {
	p.setColor(colorNew);
  }


  // abstrakte Methoden
  public abstract double area();	// Flaecheninhalt
  public abstract double perimeter(); 	// Umfang



  public abstract void draw(Graphics g);

}

// Figure (.l)
